commit 45f431bac14abd4df4a8554fcef8ba9608053a21
Author: Panagiotis Kanavos <pkanavos@gmail.com>
Date:   Fri Mar 2 11:09:05 2012 +0200

    Version changes

diff --git a/trunk/Pithos.Setup.x64/Pithos.Setup.x64.vdproj b/trunk/Pithos.Setup.x64/Pithos.Setup.x64.vdproj
index a644fec..a5b19b5 100644
--- a/trunk/Pithos.Setup.x64/Pithos.Setup.x64.vdproj
+++ b/trunk/Pithos.Setup.x64/Pithos.Setup.x64.vdproj
@@ -46,7 +46,7 @@
         "Entry"
         {
         "MsmKey" = "8:_586310F986FB0DB4F49D3EAFBD87760C"
-        "OwnerKey" = "8:_E42C4D0836CDB6008642BC929C51E416"
+        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -58,7 +58,7 @@
         "Entry"
         {
         "MsmKey" = "8:_586310F986FB0DB4F49D3EAFBD87760C"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
+        "OwnerKey" = "8:_E42C4D0836CDB6008642BC929C51E416"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -70,13 +70,13 @@
         "Entry"
         {
         "MsmKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
+        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
-        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
+        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -88,13 +88,13 @@
         "Entry"
         {
         "MsmKey" = "8:_626ECD9012C5D7BD4388B6BE07F5107D"
-        "OwnerKey" = "8:_E42C4D0836CDB6008642BC929C51E416"
+        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_626ECD9012C5D7BD4388B6BE07F5107D"
-        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
+        "OwnerKey" = "8:_E42C4D0836CDB6008642BC929C51E416"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -124,25 +124,25 @@
         "Entry"
         {
         "MsmKey" = "8:_89E3F50B2C3DDF59B632A4BEFEE3D3A1"
-        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
+        "OwnerKey" = "8:_4C5B93BC82FE5E63E01458A8DA46B4D6"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_89E3F50B2C3DDF59B632A4BEFEE3D3A1"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
+        "OwnerKey" = "8:_FBB2F726C4025B9184DFBD2748E15EBE"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_89E3F50B2C3DDF59B632A4BEFEE3D3A1"
-        "OwnerKey" = "8:_FBB2F726C4025B9184DFBD2748E15EBE"
+        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_89E3F50B2C3DDF59B632A4BEFEE3D3A1"
-        "OwnerKey" = "8:_4C5B93BC82FE5E63E01458A8DA46B4D6"
+        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -178,7 +178,7 @@
         "Entry"
         {
         "MsmKey" = "8:_A490E069DF5DE5852575B6E157EB50BE"
-        "OwnerKey" = "8:_E42C4D0836CDB6008642BC929C51E416"
+        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -190,7 +190,7 @@
         "Entry"
         {
         "MsmKey" = "8:_A490E069DF5DE5852575B6E157EB50BE"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
+        "OwnerKey" = "8:_E42C4D0836CDB6008642BC929C51E416"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -226,7 +226,7 @@
         "Entry"
         {
         "MsmKey" = "8:_C7EE41E4C982C8217BD7DCDA76836670"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
+        "OwnerKey" = "8:_E46F39A63288379E63BDD76C9F21CC3E"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -238,7 +238,7 @@
         "Entry"
         {
         "MsmKey" = "8:_C7EE41E4C982C8217BD7DCDA76836670"
-        "OwnerKey" = "8:_E46F39A63288379E63BDD76C9F21CC3E"
+        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -268,7 +268,7 @@
         "Entry"
         {
         "MsmKey" = "8:_DD70D5956F2E708F680AF121870FFCCD"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
+        "OwnerKey" = "8:_89E3F50B2C3DDF59B632A4BEFEE3D3A1"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -280,7 +280,7 @@
         "Entry"
         {
         "MsmKey" = "8:_DD70D5956F2E708F680AF121870FFCCD"
-        "OwnerKey" = "8:_89E3F50B2C3DDF59B632A4BEFEE3D3A1"
+        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -304,7 +304,7 @@
         "Entry"
         {
         "MsmKey" = "8:_E46F39A63288379E63BDD76C9F21CC3E"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
+        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -316,7 +316,7 @@
         "Entry"
         {
         "MsmKey" = "8:_E46F39A63288379E63BDD76C9F21CC3E"
-        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
+        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -328,13 +328,13 @@
         "Entry"
         {
         "MsmKey" = "8:_F472AA6700476700D62AABE8262628BF"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
+        "OwnerKey" = "8:_DD69E9C0F36E10A97EB92CFBAFD2662D"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_F472AA6700476700D62AABE8262628BF"
-        "OwnerKey" = "8:_DD69E9C0F36E10A97EB92CFBAFD2662D"
+        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -364,61 +364,61 @@
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
+        "OwnerKey" = "8:_A490E069DF5DE5852575B6E157EB50BE"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
+        "OwnerKey" = "8:_586310F986FB0DB4F49D3EAFBD87760C"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_E42C4D0836CDB6008642BC929C51E416"
+        "OwnerKey" = "8:_C7EE41E4C982C8217BD7DCDA76836670"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
+        "OwnerKey" = "8:_E46F39A63288379E63BDD76C9F21CC3E"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_71EDC030F43F0D5A22D833BE7229E576"
+        "OwnerKey" = "8:_91EEC8BDF3543C1C3379FB93171A844E"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_4C5B93BC82FE5E63E01458A8DA46B4D6"
+        "OwnerKey" = "8:_6BC141E8128E964AD9B9281537E64BEA"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_FBB2F726C4025B9184DFBD2748E15EBE"
+        "OwnerKey" = "8:_626ECD9012C5D7BD4388B6BE07F5107D"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_DD69E9C0F36E10A97EB92CFBAFD2662D"
+        "OwnerKey" = "8:_FA76529F78D7D6108EDBA33F19836A6B"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_89E3F50B2C3DDF59B632A4BEFEE3D3A1"
+        "OwnerKey" = "8:_392252B203784D91A39016FC82CD5887"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_DD70D5956F2E708F680AF121870FFCCD"
+        "OwnerKey" = "8:_B998E7FC1F540278910B0D58694455C2"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -430,61 +430,61 @@
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_B998E7FC1F540278910B0D58694455C2"
+        "OwnerKey" = "8:_DD70D5956F2E708F680AF121870FFCCD"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_392252B203784D91A39016FC82CD5887"
+        "OwnerKey" = "8:_89E3F50B2C3DDF59B632A4BEFEE3D3A1"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_FA76529F78D7D6108EDBA33F19836A6B"
+        "OwnerKey" = "8:_DD69E9C0F36E10A97EB92CFBAFD2662D"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_626ECD9012C5D7BD4388B6BE07F5107D"
+        "OwnerKey" = "8:_FBB2F726C4025B9184DFBD2748E15EBE"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_6BC141E8128E964AD9B9281537E64BEA"
+        "OwnerKey" = "8:_4C5B93BC82FE5E63E01458A8DA46B4D6"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_91EEC8BDF3543C1C3379FB93171A844E"
+        "OwnerKey" = "8:_71EDC030F43F0D5A22D833BE7229E576"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_E46F39A63288379E63BDD76C9F21CC3E"
+        "OwnerKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_C7EE41E4C982C8217BD7DCDA76836670"
+        "OwnerKey" = "8:_E42C4D0836CDB6008642BC929C51E416"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_586310F986FB0DB4F49D3EAFBD87760C"
+        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_A490E069DF5DE5852575B6E157EB50BE"
+        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
         }
     }
@@ -599,11 +599,6 @@
             "AssemblyAsmDisplayName" = "8:WPFToolkit.Extended, Version=1.5.0.0, Culture=neutral, PublicKeyToken=3e4669d2f30244f4, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_392252B203784D91A39016FC82CD5887"
-                    {
-                    "Name" = "8:WPFToolkit.Extended.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:WPFToolkit.Extended.dll"
             "TargetName" = "8:"
@@ -630,11 +625,6 @@
             "AssemblyAsmDisplayName" = "8:Castle.ActiveRecord, Version=3.0.0.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_4C5B93BC82FE5E63E01458A8DA46B4D6"
-                    {
-                    "Name" = "8:Castle.ActiveRecord.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:Castle.ActiveRecord.dll"
             "TargetName" = "8:"
@@ -661,11 +651,6 @@
             "AssemblyAsmDisplayName" = "8:log4net, Version=1.2.11.0, Culture=neutral, PublicKeyToken=669e0ddf0bb1aa2a, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_586310F986FB0DB4F49D3EAFBD87760C"
-                    {
-                    "Name" = "8:log4net.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:log4net.dll"
             "TargetName" = "8:"
@@ -692,11 +677,6 @@
             "AssemblyAsmDisplayName" = "8:System.Threading.Tasks.Dataflow, Version=0.0.4098.29463, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_5B7E11B508E123A2BA4C11623DA3E029"
-                    {
-                    "Name" = "8:System.Threading.Tasks.Dataflow.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:System.Threading.Tasks.Dataflow.dll"
             "TargetName" = "8:"
@@ -723,11 +703,6 @@
             "AssemblyAsmDisplayName" = "8:ParallelExtensionsExtras, Version=1.2.0.0, Culture=neutral, PublicKeyToken=2cc55badaa91f4de, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_626ECD9012C5D7BD4388B6BE07F5107D"
-                    {
-                    "Name" = "8:ParallelExtensionsExtras.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:ParallelExtensionsExtras.dll"
             "TargetName" = "8:"
@@ -754,11 +729,6 @@
             "AssemblyAsmDisplayName" = "8:Caliburn.Micro, Version=1.2.0.0, Culture=neutral, PublicKeyToken=8e5891231f2ed21f, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_6BC141E8128E964AD9B9281537E64BEA"
-                    {
-                    "Name" = "8:Caliburn.Micro.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:Caliburn.Micro.dll"
             "TargetName" = "8:"
@@ -785,11 +755,6 @@
             "AssemblyAsmDisplayName" = "8:System.Data.SQLite, Version=1.0.76.0, Culture=neutral, PublicKeyToken=db937bc2d44ff139, processorArchitecture=x86"
                 "ScatterAssemblies"
                 {
-                    "_71EDC030F43F0D5A22D833BE7229E576"
-                    {
-                    "Name" = "8:System.Data.SQLite.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:System.Data.SQLite.dll"
             "TargetName" = "8:"
@@ -816,11 +781,6 @@
             "AssemblyAsmDisplayName" = "8:NHibernate, Version=3.1.0.4000, Culture=neutral, PublicKeyToken=aa95f207798dfdb4, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_89E3F50B2C3DDF59B632A4BEFEE3D3A1"
-                    {
-                    "Name" = "8:NHibernate.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:NHibernate.dll"
             "TargetName" = "8:"
@@ -847,11 +807,6 @@
             "AssemblyAsmDisplayName" = "8:System.Windows.Interactivity, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_91EEC8BDF3543C1C3379FB93171A844E"
-                    {
-                    "Name" = "8:System.Windows.Interactivity.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:System.Windows.Interactivity.dll"
             "TargetName" = "8:"
@@ -878,11 +833,6 @@
             "AssemblyAsmDisplayName" = "8:AsyncCtpLibrary, Version=1.0.4107.18181, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_A490E069DF5DE5852575B6E157EB50BE"
-                    {
-                    "Name" = "8:AsyncCtpLibrary.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:AsyncCtpLibrary.dll"
             "TargetName" = "8:"
@@ -909,11 +859,6 @@
             "AssemblyAsmDisplayName" = "8:Pithos.Core, Version=1.0.0.0, Culture=neutral, PublicKeyToken=2cc55badaa91f4de, processorArchitecture=x86"
                 "ScatterAssemblies"
                 {
-                    "_A611766CD2793378FFAB2F3063F81496"
-                    {
-                    "Name" = "8:Pithos.Core.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:Pithos.Core.dll"
             "TargetName" = "8:"
@@ -960,11 +905,6 @@
             "AssemblyAsmDisplayName" = "8:Castle.Components.Validator, Version=2.5.0.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_B998E7FC1F540278910B0D58694455C2"
-                    {
-                    "Name" = "8:Castle.Components.Validator.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:Castle.Components.Validator.dll"
             "TargetName" = "8:"
@@ -991,11 +931,6 @@
             "AssemblyAsmDisplayName" = "8:Newtonsoft.Json, Version=4.0.2.0, Culture=neutral, PublicKeyToken=b9a188c8922137c6, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_C7EE41E4C982C8217BD7DCDA76836670"
-                    {
-                    "Name" = "8:Newtonsoft.Json.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:Newtonsoft.Json.dll"
             "TargetName" = "8:"
@@ -1022,11 +957,6 @@
             "AssemblyAsmDisplayName" = "8:NHibernate.ByteCode.Castle, Version=3.1.0.4000, Culture=neutral, PublicKeyToken=aa95f207798dfdb4, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_DD69E9C0F36E10A97EB92CFBAFD2662D"
-                    {
-                    "Name" = "8:NHibernate.ByteCode.Castle.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:NHibernate.ByteCode.Castle.dll"
             "TargetName" = "8:"
@@ -1053,11 +983,6 @@
             "AssemblyAsmDisplayName" = "8:Iesi.Collections, Version=1.0.1.0, Culture=neutral, PublicKeyToken=aa95f207798dfdb4, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_DD70D5956F2E708F680AF121870FFCCD"
-                    {
-                    "Name" = "8:Iesi.Collections.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:Iesi.Collections.dll"
             "TargetName" = "8:"
@@ -1084,11 +1009,6 @@
             "AssemblyAsmDisplayName" = "8:Pithos.Network, Version=1.0.0.0, Culture=neutral, PublicKeyToken=2cc55badaa91f4de, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_E42C4D0836CDB6008642BC929C51E416"
-                    {
-                    "Name" = "8:Pithos.Network.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:Pithos.Network.dll"
             "TargetName" = "8:"
@@ -1115,11 +1035,6 @@
             "AssemblyAsmDisplayName" = "8:Pithos.Interfaces, Version=1.0.0.0, Culture=neutral, PublicKeyToken=2cc55badaa91f4de, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_E46F39A63288379E63BDD76C9F21CC3E"
-                    {
-                    "Name" = "8:Pithos.Interfaces.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:Pithos.Interfaces.dll"
             "TargetName" = "8:"
@@ -1146,11 +1061,6 @@
             "AssemblyAsmDisplayName" = "8:Castle.Core, Version=2.5.1.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_F472AA6700476700D62AABE8262628BF"
-                    {
-                    "Name" = "8:Castle.Core.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:Castle.Core.dll"
             "TargetName" = "8:"
@@ -1177,11 +1087,6 @@
             "AssemblyAsmDisplayName" = "8:Hardcodet.Wpf.TaskbarNotification, Version=1.0.4.0, Culture=neutral, PublicKeyToken=2cc55badaa91f4de, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_FA76529F78D7D6108EDBA33F19836A6B"
-                    {
-                    "Name" = "8:Hardcodet.Wpf.TaskbarNotification.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:Hardcodet.Wpf.TaskbarNotification.dll"
             "TargetName" = "8:"
@@ -1208,11 +1113,6 @@
             "AssemblyAsmDisplayName" = "8:NHibernate.Search, Version=0.0.0.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_FBB2F726C4025B9184DFBD2748E15EBE"
-                    {
-                    "Name" = "8:NHibernate.Search.dll"
-                    "Attributes" = "3:512"
-                    }
                 }
             "SourcePath" = "8:NHibernate.Search.dll"
             "TargetName" = "8:"
@@ -1310,15 +1210,15 @@
         {
         "Name" = "8:Microsoft Visual Studio"
         "ProductName" = "8:Pithos"
-        "ProductCode" = "8:{871B6E5B-9773-43A7-B128-29CC044ED231}"
-        "PackageCode" = "8:{92373269-1FD4-4034-84D7-54D1E333A7E0}"
+        "ProductCode" = "8:{57BE17ED-F02F-43C0-B44B-845697CD3D6A}"
+        "PackageCode" = "8:{088CDA63-20EF-47B5-A8A5-6A64BAAF98E3}"
         "UpgradeCode" = "8:{205365D1-28AA-4322-A46C-FCB37502C6EF}"
         "AspNetVersion" = "8:4.0.30319.0"
         "RestartWWWService" = "11:FALSE"
         "RemovePreviousVersions" = "11:TRUE"
         "DetectNewerInstalledVersion" = "11:TRUE"
         "InstallAllUsers" = "11:FALSE"
-        "ProductVersion" = "8:0.7.20301"
+        "ProductVersion" = "8:0.7.20302"
         "Manufacturer" = "8:GRNET"
         "ARPHELPTELEPHONE" = "8:"
         "ARPHELPLINK" = "8:http://code.grnet.gr/projects/pithos-ms-client"